123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511 |
- #!/bin/bash
- OSInfo() {
-
- OS=$(uname -s)
- if [ $OS = "Linux" ]; then
- OS="GNU/Linux"
- if [ -f /etc/os-release ]; then
- DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
- REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
- ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
- for i in $ID_LIKE; do
-
- case $i in
- debian|ubuntu)
- debianOS=true
- break
- ;;
- rhel|fedora)
- rhelOS=true
- break
- ;;
- *)
- debianOS=false
- rhelOS=false
- ;;
- esac
- done
- elif [ -f /etc/debian-version ]; then
-
- DIST="Debian"
- REV=""
- ID_LIKE="debian"
- debianOS=true
- elif [ -f /etc/redhat-release ]; then
-
- DIST="Red-Hat"
- REV=""
- ID_LIKE="rhel"
- rhelOS=true
- else
-
- DIST=""
- REV=""
- ID_LIKE=""
- fi
- else
-
- DIST=$OS
- REV=""
- fi
-
- HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
- }
- comprobarRoot() {
- if [ $(id -u) -ne 0 ]; then
- printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
- exit 1
- fi
- }
- comprobarDependencias() {
-
- which whiptail > /dev/null 2>&1
- if [ $? -ne 0 ];then
- printf "ERROR:\t'whiptail' no disponible.\n"
- exit 1
- fi
-
- which hostnamectl > /dev/null 2>&1
- if [ $? -ne 0 ];then
- printf "ERROR:\t'hostnamectl' no disponible.\n"
- exit 1
- fi
- if [ $debianOS = true ];then
-
- which apt-get > /dev/null 2>&1
- if [ $? -ne 0 ]; then
- printf "ERROR:\t'apt-get' no está disponible.\n"
- exit 1
- fi
-
- printf "Actualizando repositorio APT..."
- result=$(apt-get -q -y update)
- if [ $? -ne 0 ]; then
- printf "\nERROR:\tImposible actualizar repositorio.\n"
- printf "Detalles:\n$result\n"
- exit 1
- fi
- printf " OK.\n"
-
- which ufw > /dev/null 2>&1
- if [ $? -ne 0 ]; then
- printf "ERROR:\t'ufw' no disponible.\n"
- exit 1
- fi
- fi
- if [ $rhelOS = true ]; then
-
- which yum > /dev/null 2>&1
- if [ $? -ne 0 ]; then
- printf "ERROR:\t'yum' no está disponible.\n"
- exit 1
- fi
-
- printf "Actualizando repositorio YUM..."
- result=$(yum -y makecache 2>&1)
- if [ $? -ne 0 ]; then
- printf "\nERROR:\tImposible actualizar repositorio.\n"
- printf "Detalles:\n$result\n"
- exit 1
- fi
- printf " OK.\n"
-
- which firewall-cmd > /dev/null 2>&1
- if [ $? -ne 0 ]; then
- printf "ERROR:\t'firewall-cmd' no disponible.\n"
- exit 1
- fi
- fi
- }
- inicializarVariables() {
- debianOS=false
- rhelOS=false
- apacheOn=false
- nginxOn=false
- mySQLOn=false
- mariaDBOn=false
- phpOn=false
- mediaWikiOn=false
- moodleOn=false
- actualizacionesOn=false
- }
- instalacionExpress() {
- apacheOn=true
- mariaDBOn=true
- phpOn=true
- mediaWikiOn=true
- moodleOn=true
- actualizacionesOn=true
- }
- mostrarBienvenida() {
- if [ $debianOS = false ] && [ $rhelOS = false ]; then
- whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" 20 70 --ok-button "Salir"
- exit 1
- fi
- whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" 20 70 --yes-button "Continuar" --no-button "Salir"
- if [ $? -ne 0 ]; then
- printf "ERROR:\tInstalación interrumpida por el usuario.\n"
- exit 2
- fi
- }
- mostrarExpress() {
- express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" 20 70 2 \
- "Express" "Instalación rápida" ON \
- "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
- --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
- if [ $? -ne 0 ]; then
- printf "ERROR:\tInstalación interrumpida por el usuario.\n"
- exit 2
- fi
- case $express in
- Express)
- instalacionExpress
-
- ;;
- Avanzada)
- mostrarAvanzada
- ;;
- *)
- printf "ERROR:\tError interno (selección express).\n"
- exit 1
- ;;
- esac
- }
- mostrarAvanzada() {
- componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 7 \
- "WebServer" "Instalar servidor web http/https" ON \
- "Database" "Instalar una base de datos SQL" ON \
- "PHP" "Instala PHP7" ON \
- "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
- "MediaWiki" "Instalar wiki con MediaWiki" ON \
- "Moodle" "Instalar campus virtual con Moodle" ON \
- "Actualizaciones" "Programar actualizaciones automáticas" ON \
- --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
- if [ $? -ne 0 ]; then
- printf "ERROR:\tInstalación interrumpida por el usuario.\n"
- exit 2
- fi
-
- for i in $componentes; do
- case $i in
- \"WebServer\")
- mostrarWebServer
- ;;
- \"Database\")
- mostrarDatabase
- ;;
- \"PHP\")
- phpOn=true
- ;;
- \"SSL/TLS\")
-
- ;;
- \"MediaWiki\")
- mediaWikiOn=true
- ;;
- \"Moodle\")
- moodleOn=true
- ;;
- \"Actualizaciones\")
- actualizacionesOn=true
- ;;
- *)
- printf "ERROR:\tError interno (selección de componentes).\n"
- exit 1
- ;;
- esac
- done
- }
- mostrarWebServer() {
- webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" 20 70 2 \
- "Apache" "Instalar el servidor web Apache2" ON \
- "Nginx" "Instalar el servidor web Nginx" OFF \
- --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
- if [ $? -ne 0 ]; then
- printf "ERROR:\tInstalación interrumpida por el usuario.\n"
- exit 2
- fi
- case $webServer in
- Apache)
- apacheOn=true
- ;;
- Nginx)
- nginxOn=true
- ;;
- *)
- printf "ERROR:\tError interno (selección de web server).\n"
- exit 1
- ;;
- esac
-
- establecerFQDN
- }
- establecerFQDN() {
- while [ -z $hostname ]; do
- hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" 20 70 --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
- if [ $? -eq 0 ] && [ ! -z $hostname ]; then
- hostnamectl set-hostname $hostname
- else
- hostname=$(hostname)
- fi
- done
-
- }
- instalarApache() {
- if [ $debianOS = true ];then
- result=$(apt-get -q -y install apache2 2>&1)
- if [ $? -ne 0 ]; then
- printf "\nERROR:\tError al instalar Apache2.\n"
- printf "Detalles:\n$result\n"
- exit 1
- fi
- elif [ $rhelOS = true ]; then
- result=$(yum -y install httpd 2>&1)
- if [ $? -ne 0 ]; then
- printf "\nERROR:\tError al instalar Apache2.\n"
- printf "Detalles:\n$result\n"
- exit 1
- fi
- else
- printf "\nERROR:\tError interno (instalación Apache2).\n"
- exit 1
- fi
- }
- instalarNginx() {
- if [ $debianOS = true ];then
- result=$(apt-get -q -y install nginx 2>&1)
- if [ $? -ne 0 ]; then
- printf "\nERROR:\tError al instalar Nginx.\n"
- printf "Detalles:\n$result\n"
- exit 1
- fi
- elif [ $rhelOS = true ]; then
-
- result=$(yum -y install epel-release)
- if [ $? -ne 0 ]; then
- printf "\nERROR:\tError al intalar repositorio 'epel-release'.\n"
- printf "Detalles:\n$result\n"
- exit 1
- fi
- result=$(yum -y install nginx 2>&1)
- if [ $? -ne 0 ]; then
- printf "\nERROR:\tError al instalar Nginx.\n"
- printf "Detalles:\n$result\n"
- exit 1
- fi
- else
- printf "\nERROR:\tError interno (instalación Nginx).\n"
- exit 1
- fi
- }
- mostrarDatabase() {
- if [ $debianOS = true ]; then
- database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" 20 70 2 \
- "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
- "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
- --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
- if [ $? -ne 0 ]; then
- printf "ERROR:\tInstalación interrumpida por el usuario.\n"
- exit 2
- fi
- case $database in
- MySQL)
- mySQLOn=true
- ;;
- MariaDB)
- mariaDBOn=true
- ;;
- *)
- printf "ERROR:\tError interno (selección de base de datos).\n"
- exit 1
- ;;
- esac
- elif [ $rhelOS = true ]; then
- whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." 20 70 --yes-button "Continuar" --no-button "Salir"
- if [ $? -ne 0 ]; then
- printf "ERROR:\tInstalación interrumpida por el usuario.\n"
- exit 2
- fi
- mariaDBOn=true
- else
- printf "ERROR:\tError interno (instalación Base de Datos).\n"
- exit 1
- fi
-
- establecerSQLPasswd
- }
- establecerSQLPasswd() {
- control=false
-
- while [ $control = false ]; do
- sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Introduzca la contraseña para el usuario 'root' de la base de datos:" 20 70 --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
- if [ $? -ne 0 ]; then
- printf "ERROR:\tInstalación interrumpida por el usuario.\n"
- exit 2
- fi
- sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" 20 70 --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
- if [ $? -ne 0 ];then
- printf "ERROR:\tInstalación interrumpida por el usuario.\n"
- exit 2
- fi
- if [ $sqlPasswd = $sqlPasswd2 ];then
- control=true
- fi
- done
-
- unset control sqlPasswd2
- }
- instalarMySQL() {
- if [ $debianOS = true ];then
- result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
- if [ $? -ne 0 ]; then
- printf "\nERROR:\tError al instalar MySQL.\n"
- printf "Detalles:\n$result\n"
- exit 1
- fi
- elif [ $rhelOS = true ]; then
-
-
-
- printf "\nERROR:\tRHEL no incluye MySQL en sus repositorios.\n"
- exit 1
- else
- printf "\nERROR:\tError interno (instalación MySQL).\n"
- exit 1
- fi
- }
- instalarMariaDB() {
- if [ $debianOS = true ];then
- result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
- if [ $? -ne 0 ]; then
- printf "\nERROR:\tError al instalar MariaDB.\n"
- printf "Detalles:\n$result\n"
- exit 1
- fi
- elif [ $rhelOS = true ]; then
- result=$(yum -y install mariadb-server 2>&1)
- if [ $? -ne 0 ]; then
- printf "\nERROR:\tError al instalar MariaDB.\n"
- printf "Detalles:\n$result\n"
- exit 1
- fi
- else
- printf "\nERROR:\tError interno (instalación MariaDB).\n"
- exit 1
- fi
- }
- comprobarRoot
- inicializarVariables
- OSInfo
- comprobarDependencias
- mostrarBienvenida
- mostrarExpress
-
-
-
-
- if [ $apacheOn = true ]; then
- printf "Instalando Web Server Apache..."
- instalarApache
- printf " OK.\n"
- elif [ $nginxOn = true ]; then
- printf "Instalando Web Server Nginx..."
- instalarNginx
- printf " OK.\n"
- fi
-
- if [ $mySQLOn = true ]; then
- printf "Instalando Base de Datos MySQL..."
- instalarMySQL
- printf " OK.\n"
- elif [ $mariaDBOn = true ]; then
- printf "Instalando Base de Datos MariaDB..."
- instalarMariaDB
- printf " OK.\n"
- fi
-
- if [ $phpOn = true ]; then
- printf "Instalando PHP-7..."
- printf " OK.\n"
- fi
-
-
-
- if [ $mediaWikiOn = true ]; then
- printf "Instalando MediaWiki..."
- printf " OK.\n"
- fi
-
- if [ $moodleOn = true ]; then
- printf "Instalando Moodle..."
- printf " OK.\n"
- fi
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
- if [ $actualizacionesOn = true ]; then
- printf "Configurando actualizaciones automáticas..."
-
- printf " OK.\n"
- fi
- {
- for i in $(seq 0 5 50); do
- sleep 0.1
- echo $i
- done
- } | whiptail --gauge "Autodestrucción..." 7 70 0
- {
- for i in $(seq 50 5 100); do
- sleep 0.1
- echo $i
- done
- } | whiptail --gauge "Autopulverización..." 7 70 50
|